# N9 command-line interface utilities
# N9 Package Builder
# 2007 cyberlight systems research lab

import sys;
import string
import N9;
import os.path;


def print_Help():
    print """n9mkpkg - codename:N9 package building utility.
licensed under GPL v.2
(c) 2007 cyberlight systems
usage: n9mkpkg PACKAGE-FILE BOOTDRIVE-FILE RAM NAME [redirectsfile] [... other params ...]
where:
\tPACKAGE-FILE    - target .tgz package file name
\tBOOTDRIVE-FILE  - primary boot disk for packaged virtual machine
\tNAME            - virtual machine display name (i.e "Linux 2.6")
\tRAM             - RAM amount in MB
\t[redirectsfile] - optional port redirection config file
for more options see readme.txt"""

def print_Error():
    print 'Invalid arguments. Run n9mkpkg with "-help" switch for exploring usage';

def do_MakePackage():
#d[SYM_MACHINE_BOOTDRIVE] = '.\\machines\\101\\Windows.98.hdd'
#d[SYM_MACHINE_NAME] = 'Windows 98';
#d[SYM_MACHINE_PACKAGE] = 'windows-98-rus';
#d[SYM_MACHINE_REDIRCFG] = '.\\machines\\101\\redirects.cfg';
#d[SYM_MACHINE_DISPLAY] = SYM_DISPLAY_SDL
#print create_Package(d, '.\\windows-98-rus.tgz');
    ind = 1
    for i in sys.argv[1:len(sys.argv)]:
        ct = i;
        ct = string.replace(ct, '"', '');
        ct = string.replace(ct, '\n', '');
        sys.argv[ind] = ct; 
        ind = ind + 1
    package = sys.argv[1];
    params = N9.initialize_Config()
    params[N9.SYM_MACHINE_BOOTDRIVE] = sys.argv[2];
    params[N9.SYM_MACHINE_RAM] = sys.argv[3]
    params[N9.SYM_MACHINE_NAME] = sys.argv[4];
    params[N9.SYM_MACHINE_DISPLAY] = N9.SYM_DISPLAY_SDL;
    params[N9.SYM_MACHINE_NIC] = N9.SYM_NIC_RTL8139;
    if len(sys.argv) > 5:
        if os.path.exists(sys.argv[5]):
            if os.path.isfile(sys.argv[5]):
                params[N9.SYM_MACHINE_REDIRCFG] = sys.argv[5]
        else:
            #pass entire keys from 4 to end here
            for s in sys.argv[5:len(sys.argv)]:
                t = string.split(s, '=', 1);
                key = t[0];
                value = t[1];
                if key in N9.QVM_SYMBOLS:
                    params[key] = value;

    print 'Building package ...'
    N9.create_Package(params, package);
    print 'Building package done:'

if __name__ == '__main__':
    #print sys.argv, len(sys.argv)
    if len(sys.argv) <= 1:
        print_Help();
    else:
        if len(sys.argv) == 2 and (string.upper(sys.argv[1]) == '--HELP' or
         string.upper(sys.argv[1]) == '-HELP' or
         string.upper(sys.argv[1]) == '-H' or
         string.upper(sys.argv[1]) == '-?' or
         string.upper(sys.argv[1]) == '/?'):
            print_Help();
        else:
            if len(sys.argv) >= 5:
                do_MakePackage();
            else:
                print_Error();
         
    
